editor = "ED"   ; Change this to your word processor

PROC BuildHdrForm()
  {Forms} {Design} {Header} {2} {BriefHeader}         ; Design form for HEADER
  " Date Recvd      From                 Subject"     ; Place text...
  ENTER
  " -----------  ------------------  ----------------------------------------------------------"
  ENTER
  " "
  MENU {Field} {Place} {Regular} {Date Received}      ; Place DATE field
  ENTER ENTER RIGHT
  MENU {Field} {Place} {Regular} {From User}          ; Place FROM USER field
  ENTER ENTER RIGHT
  MENU {Field} {Place} {Regular} {Subject}            ; Place SUBJECT field
  ENTER ENTER CTRLHOME
  MENU {Multi} {Records} {Define}                     ; Define as MultiRecord
  ENTER LEFT ENTER DOWN DOWN DOWN DOWN DOWN DOWN DOWN ENTER
  DO_IT!                                              ; Save this form
ENDPROC  ; BuildHdrForm

PROC BuildMsgForms()
   {Forms} {Design} {Message} {1} {Message Body}   ; Design form for MESSAGE
   MENU {Field} {Place} {Regular} {Line#}          ; Place LINE# field
   ENTER LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT  ; Truncate field size
   LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT LEFT ENTER

   ; The next four lines set up the position and color for hiding the line#
   ; field. It currently sets the color to a light grey on light grey.
   HOME CTRLHOME
   MENU {Style} {Color} {Area}
   ENTER DOWN DOWN DOWN DOWN DOWN DOWN DOWN DOWN ENTER
   RIGHT RIGHT RIGHT RIGHT RIGHT RIGHT RIGHT ENTER
   DO_IT!                                     ; Save this form

   {Forms} {Design} {Header} {1} {Message}    ; Design form for HEADER table
   ENTER "   Date Received  "
   MENU {Field} {Place} {Regular} {Date Received}  ; Place DATE RECEIVED field

   ENTER ENTER ENTER  "   Subject .... "       ; Set up position and text
   MENU {Field} {Place} {Regular} {From User}  ; Place FROM USER field
   ENTER ENTER
   MENU {Multi} {Tables} {Place}          ; Place MultiTable linked form from
   {Linked} {Message} {1} {Message#}      ; MESSAGE table.
   UP UP UP UP UP UP UP UP UP ENTER       ; Position the field

   DO_IT!                                 ; Save this form
ENDPROC       ; BuildMsgForms

PROC MenuScrn()
   CANVAS OFF
   @4,0
   SETMARGIN 25

   PAINTCANVAS ATTRIBUTE 31 2, 0, 24, 79 ; Fill Background w/White on Blue
   PAINTCANVAS ATTRIBUTE 0 5, 27, 8, 54  ; Shadow Box in Black
   STYLE ATTRIBUTE 7
   TEXT
------------------------------
|     MCI Message System     |
|                            |
------------------------------
   ENDTEXT

   SETMARGIN 0
   @22,0

   TEXT
--------------------------------------------------------------------------------
     Use Cursor Keys <- -> To Move Between Menu Choices, or 1st Character
--------------------------------------------------------------------------------
   ENDTEXT
   PAINTCANVAS ATTRIBUTE 31 22, 0, 24, 79
   CANVAS ON
ENDPROC   ;MenuScrn

PROC Inbox()
   IF (ISEMPTY("Header")) THEN
     @20,27
     ?? "No messages to be viewed"
     RETURN
   ENDIF
   VIEW "Header"
   PICKFORM 2
   WAIT TABLE
     PROMPT "Arrow to message, press RETURN to view",
            "ESC aborts to main menu."
   UNTIL "Enter", "Esc"

   SWITCH
      CASE retval = "Enter":
          ViewMessage()
      CASE retval = "Esc":
          CLEAR
          CLEARALL
          RETURN
   ENDSWITCH
ENDPROC   ; Inbox

PROC ViewMessage()
   PICKFORM 1
   DOWNIMAGE
   WHILE (TRUE)
      WAIT TABLE
      PROMPT "F3/F4 move to Previous/Next message. INS responds to message.",
             "Arrow keys scroll the current message. ESC aborts to main menu."
      UNTIL "Esc","F3","F4","Ins"

      SWITCH
         CASE retval = "Ins":
            Respond()
            PICKFORM 1
            DOWNIMAGE
         CASE retval = "F3":
            UPIMAGE
            PGUP
            DOWNIMAGE
         CASE retval = "F4":
            UPIMAGE
            PGDN
            DOWNIMAGE
         CASE retval = "Esc":
            QUITLOOP
      ENDSWITCH
   ENDWHILE
   CLEAR
   CLEARALL
ENDPROC  ; ViewMessage

PROC CheckPending()
   IF (NOT ISTABLE("Pending")) THEN
      CREATE "Pending"
         "Pending#" : "N*",
         "Action"   : "A8*",
         "Text"     : "A40*"
      RETURN 1
   ELSE
      IF (ISEMPTY("Pending")) THEN
         RETURN 1
      ELSE
         RETURN CMAX("Pending","Pending#") + 1
      ENDIF
   ENDIF
ENDPROC  ; CheckPending

PROC Respond()
   UPIMAGE
   mnum    = [Message#]
   subject = [Subject]
   from    = [From ID]
   pnum    = CheckPending()

   MENU {Ask} {Route}
   MOVETO [TOorCC] CHECK
   MOVETO [User ID] CHECK
   [MESSAGE#] = mnum
   DO_IT!

   VIEW "Answer"
   IF (ISEMPTY("Answer")) THEN
      answerTable=TRUE
   ELSE
      answerTable=FALSE
   ENDIF
   VIEW "Pending"
   EDIT "Pending"
   END
   DOWN
   [Pending#] = pnum
   [Action]   = "Filename"
   [Text]     = "Pending " + STRVAL(pnum)
   DOWN
   [Pending#] = pnum
   [Action]   = "Subject"
   [Text]     = "RE:" + subject
   DOWN
   [Pending#] = pnum
   [Action]   = "TO"
   [Text]     = from
   DOWN
   UPIMAGE

   IF (NOT answerTable) THEN
      WHILE (TRUE)
         to_cc = [TOorCC]
         uid   = [User ID]

         DOWNIMAGE
         [Pending#] = pnum
         [Action]   = to_cc
         [Text]     = uid
         DOWN

         UPIMAGE
         IF (ATLAST()) THEN
            QUITLOOP
         ENDIF
         DOWN
      ENDWHILE
   ENDIF

   DO_IT!

   RUN BIG editor + " Pending." + STRVAL(pnum)
   CLEAR
   CLEARIMAGE         ; Close the Pending Table
   CLEARIMAGE         ; Close the Answer Table
   UPIMAGE
   CLEARIMAGE         ; Close the Route Query Table
ENDPROC  ; Respond()

PROC Compose()
   pnum = CheckPending()

   VIEW "Pending"
   EDIT "Pending"
   END
   DOWN

   [Pending#] = pnum
   [Action]   = "Filename"
   [Text]     = "Pending." + STRVAL(pnum)
   DOWN

   CLEAR
   @0,0
   GetMultiple("TO",TRUE);
   IF (NOT retval) THEN
      CANCELEDIT
      CLEAR
      CLEARALL
      RETURN
   ENDIF

   sub = ""
   WHILE(LEN(sub) = 0)
      ? "Subject: "
      ACCEPT "A40" TO sub
      IF (NOT retval) THEN
         CANCELEDIT
         CLEAR
         CLEARALL
         RETURN
      ENDIF
   ENDWHILE
   [Pending#] = pnum
   [Action]   = "Subject"
   [Text]     = sub

   DO_IT!

   RUN BIG editor + "Pending." + STRVAL(pnum)
   CLEAR
   CLEARALL
ENDPROC  ; Compose

PROC GetMultiple(where,one)
   IF (one) THEN
      name = ""
      WHILE (LEN(name) = 0)       ; Loop until at least one [where] field
         ? WHERE + ": "           ; has been input.
         ACCEPT "A20" TO name
         IF (NOT retval) THEN     ; Esc was pressed
            RETURN FALSE
         ENDIF
      ENDWHILE
      [Pending#] = pnum
      [Action]   = where
      [Text]     = name
      DOWN
   ENDIF

   WHILE (TRUE)
      ? where + ": "
      ACCEPT "A20" TO name
      IF (NOT retval) THEN        ; Esc was pressed
         RETURN FALSE
      ENDIF
      IF (LEN(name) = 0) THEN
         QUITLOOP
      ENDIF
      [Pending#] = pnum
      [Action]   = where
      [Text]     = name
      DOWN
   ENDWHILE
   RETURN TRUE
ENDPROC  ; GetMultiple

PROC Main()
   WHILE (TRUE)
      Menuscrn()

      SHOWMENU
         "Inbox"   : "View Current Messages",
         "Compose" : "Compose a new Message",
         "Quit"    : "Quit the MCI Message System"
      TO choice

      SWITCH
         CASE choice = "Inbox":
            Inbox()
         CASE choice = "Compose":
            Compose()
         CASE choice = "Quit":
            SHOWMENU
               "No"  : "Do NOT Quit The Application",
               "Yes" : "Quit The Application."
            TO theexit
            IF (theexit = "Yes") THEN
               EXIT
            ENDIF
      ENDSWITCH
   ENDWHILE
ENDPROC  ; Main

